-- This file is automatically generated using maintenance/generateSchemaSql.php.
-- Source: schema/tables.json
-- Do not modify this file directly.
-- See https://www.mediawiki.org/wiki/Manual:Schema_changes
CREATE TABLE /*_*/swsite (
  sws_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
  sws_name BLOB NOT NULL, sws_short_name BLOB NOT NULL,
  sws_site_uri BLOB NOT NULL, sws_user_uri BLOB NOT NULL,
  sws_work_uri BLOB NOT NULL
);

CREATE UNIQUE INDEX swsite_name ON /*_*/swsite (sws_name);

CREATE UNIQUE INDEX swsite_short_name ON /*_*/swsite (sws_short_name);

CREATE UNIQUE INDEX swsite_site_uri ON /*_*/swsite (sws_site_uri);

CREATE UNIQUE INDEX swsite_user_uri ON /*_*/swsite (sws_user_uri);

CREATE UNIQUE INDEX swsite_work_uri ON /*_*/swsite (sws_work_uri);


CREATE TABLE /*_*/swauthor (
  swa_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
  swa_site INTEGER UNSIGNED NOT NULL,
  swa_user_name BLOB DEFAULT NULL, swa_real_name BLOB DEFAULT NULL,
  swa_uri_part BLOB NOT NULL
);

CREATE UNIQUE INDEX swauthor_namesite_unique ON /*_*/swauthor (swa_site, swa_user_name);


CREATE TABLE /*_*/srcwork (
  srcwork_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
  srcwork_site INTEGER UNSIGNED NOT NULL,
  srcwork_creator INTEGER UNSIGNED NOT NULL,
  srcwork_date BLOB NOT NULL, srcwork_title BLOB DEFAULT '' NOT NULL,
  srcwork_uri_part BLOB NOT NULL
);

CREATE UNIQUE INDEX srcwork_uridate_unique ON /*_*/srcwork (
  srcwork_site, srcwork_uri_part, srcwork_date
);


CREATE TABLE /*_*/swauthor_links (
  swal_srcworkid INTEGER UNSIGNED NOT NULL,
  swal_authorid INTEGER UNSIGNED NOT NULL
);

CREATE UNIQUE INDEX swal_srcwork_author_unique ON /*_*/swauthor_links (swal_srcworkid, swal_authorid);


CREATE TABLE /*_*/swsource_links (
  swsl_workid INTEGER UNSIGNED NOT NULL,
  swsl_sourceid INTEGER UNSIGNED NOT NULL,
  swsl_comment BLOB DEFAULT '' NOT NULL
);

CREATE UNIQUE INDEX swsl_work_source_unique ON /*_*/swsource_links (swsl_workid, swsl_sourceid);


CREATE TABLE /*_*/revsrc (
  revsrc_revid INTEGER UNSIGNED NOT NULL,
  revsrc_srcworkid INTEGER UNSIGNED NOT NULL,
  revsrc_timestamp BLOB NOT NULL, revsrc_user INTEGER UNSIGNED NOT NULL,
  revsrc_user_text CLOB NOT NULL, revsrc_comment CLOB NOT NULL
);

CREATE UNIQUE INDEX revsrc_rs_unique ON /*_*/revsrc (revsrc_revid, revsrc_srcworkid);

CREATE INDEX revsrc_revid_index ON /*_*/revsrc (revsrc_revid);

CREATE INDEX revsrc_timestamp_index ON /*_*/revsrc (revsrc_timestamp);
